org.optaplanner.core.impl.solver.termination

## Class AndCompositeTermination

- java.lang.Object
- - org.optaplanner.core.impl.solver.event.SolverLifecycleListenerAdapter<Solution_>
  - - org.optaplanner.core.impl.phase.event.PhaseLifecycleListenerAdapter
    - - org.optaplanner.core.impl.solver.termination.AbstractTermination
      - - org.optaplanner.core.impl.solver.termination.AbstractCompositeTermination
        - - org.optaplanner.core.impl.solver.termination.AndCompositeTermination

- All Implemented Interfaces:
    EventListener, PhaseLifecycleListener, SolverLifecycleListener, Termination

      public class AndCompositeTermination
      extends AbstractCompositeTermination

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.solver.termination.AbstractCompositeTermination

      `terminationList`

    - ### Fields inherited from class org.optaplanner.core.impl.solver.termination.AbstractTermination

      `logger`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AndCompositeTermination(List<Termination> terminationList)`
    `AndCompositeTermination(Termination... terminations)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `double` | `calculatePhaseTimeGradient(AbstractPhaseScope phaseScope)` Calculates the minimum timeGradient of all Terminations.
    `double` | `calculateSolverTimeGradient(DefaultSolverScope solverScope)` Calculates the minimum timeGradient of all Terminations.
    `AndCompositeTermination` | `createChildThreadTermination(DefaultSolverScope solverScope, ChildThreadType childThreadType)` Create a `Termination` for a child `Thread` of the `Solver`.
    `boolean` | `isPhaseTerminated(AbstractPhaseScope phaseScope)` Called by the `Phase` after every step and every move to determine if the search should stop.
    `boolean` | `isSolverTerminated(DefaultSolverScope solverScope)` Called by the `Solver` after every phase to determine if the search should stop.
    `String` | `toString()`

    - ### Methods inherited from class org.optaplanner.core.impl.solver.termination.AbstractCompositeTermination

      `createChildThreadTerminationList, phaseEnded, phaseStarted, solvingEnded, solvingStarted, stepEnded, stepStarted`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AndCompositeTermination

          public AndCompositeTermination(List<Termination> terminationList)

    - #### AndCompositeTermination

          public AndCompositeTermination(Termination... terminations)

  - ### Method Detail

    - #### isSolverTerminated

          public boolean isSolverTerminated(DefaultSolverScope solverScope)

      Description copied from interface: `Termination`
      Called by the `Solver` after every phase to determine if the search should stop.
      Parameters:
        `solverScope` - never null
      Returns:
        true if all the Terminations are terminated.

    - #### isPhaseTerminated

          public boolean isPhaseTerminated(AbstractPhaseScope phaseScope)

      Description copied from interface: `Termination`
      Called by the `Phase` after every step and every move to determine if the search should stop.
      Parameters:
        `phaseScope` - never null
      Returns:
        true if all the Terminations are terminated.

    - #### calculateSolverTimeGradient

          public double calculateSolverTimeGradient(DefaultSolverScope solverScope)

      Calculates the minimum timeGradient of all Terminations. Not supported timeGradients (-1.0) are ignored.
      Parameters:
        `solverScope` - never null
      Returns:
        the minimum timeGradient of the Terminations.

    - #### calculatePhaseTimeGradient

          public double calculatePhaseTimeGradient(AbstractPhaseScope phaseScope)

      Calculates the minimum timeGradient of all Terminations. Not supported timeGradients (-1.0) are ignored.
      Parameters:
        `phaseScope` - never null
      Returns:
        the minimum timeGradient of the Terminations.

    - #### createChildThreadTermination

          public AndCompositeTermination createChildThreadTermination(DefaultSolverScope solverScope,
                                                                      ChildThreadType childThreadType)

      Description copied from interface: `Termination`
      Create a `Termination` for a child `Thread` of the `Solver`.
      Specified by:
        `createChildThreadTermination` in interface `Termination`
      Overrides:
        `createChildThreadTermination` in class `AbstractTermination`
      Parameters:
        `solverScope` - never null
        `childThreadType` - never null
      Returns:
        not null

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2006–2020 JBoss by Red Hat. All rights reserved.